package co.jp.app.service;

<<<<<<< HEAD
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.crypto.password.PasswordEncoder;
import org.springframework.stereotype.Service;

import co.jp.app.entity.UserEntity;
import co.jp.app.repository.userRepository;
import jakarta.transaction.Transactional;

=======
import java.util.Collection;
import java.util.Collections;
import java.util.List;

import co.jp.app.dto.RegistrationDto;
import co.jp.app.entity.UserEntity;
import co.jp.app.repository.UserRepository;
import org.jetbrains.annotations.NotNull;
import org.springframework.security.core.GrantedAuthority;
import org.springframework.security.core.authority.SimpleGrantedAuthority;
import org.springframework.security.core.userdetails.User;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.security.core.userdetails.UserDetailsService;
import org.springframework.security.core.userdetails.UsernameNotFoundException;
import org.springframework.security.crypto.password.PasswordEncoder;
import org.springframework.stereotype.Service;

import co.jp.app.entity.PetEntity;
import co.jp.app.repository.UploadRepository;
import org.springframework.transaction.annotation.Transactional;
>>>>>>> 34de018ef0606dec4f6de48c8cc5c3f073a1fdc6

@Service
public class UserService implements UserDetailsService {

<<<<<<< HEAD
	private final userRepository userEntityRepository;

	@Autowired
	public UserService(userRepository userEntityRepository, PasswordEncoder passwordEncoder )
	{
		this.userEntityRepository = userEntityRepository;
		this.passwordEncoder= passwordEncoder;
		
=======
	private final UserRepository userRepository;
	private final PasswordEncoder passwordEncoder;

	public UserService(UserRepository userRepository, PasswordEncoder passwordEncoder) {
		this.userRepository = userRepository;
		this.passwordEncoder = passwordEncoder;
>>>>>>> 34de018ef0606dec4f6de48c8cc5c3f073a1fdc6
	}

	@Transactional
	public UserEntity registerNewUser(@NotNull RegistrationDto registrationDto) throws Exception {

		if (userRepository.existsByEmail(registrationDto.getEmail())) {
			throw new Exception("エラー：メール：" + registrationDto.getEmail() + " はすでに登録されました。");
		}

		UserEntity newUser = new UserEntity();
		newUser.setName(registrationDto.getName());
		newUser.setEmail(registrationDto.getEmail());
		newUser.setPassword(passwordEncoder.encode(registrationDto.getPassword()));

		return userRepository.save(newUser);
	}

	@Override
	@Transactional(readOnly = true)
	public UserDetails loadUserByUsername(String email) throws UsernameNotFoundException {
		UserEntity userEntity = userRepository.findByEmail(email)
				.orElseThrow(() -> new UsernameNotFoundException(email + " not found"));

		Collection<? extends GrantedAuthority> authorities = Collections.singletonList(new SimpleGrantedAuthority("ROLE_USER")); // 示例：给所有用户一个ROLE_USER权限

		return new User(
				userEntity.getEmail(),
				userEntity.getPassword(),
				true,                // enabled
				true,                       // accountNonExpired
				true,                       // credentialsNonExpired
				true,                       // accountNonLocked
				authorities                 // 用户的权限集合
		);
	}
}
